Code

Merge branch 'js/merge-base'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset AUTHOR_DATE
15 unset AUTHOR_EMAIL
16 unset AUTHOR_NAME
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 unset GIT_AUTHOR_DATE
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_DIFF_OPTS
27 unset GIT_DIR
28 unset GIT_EXTERNAL_DIFF
29 unset GIT_INDEX_FILE
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
33 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 export EDITOR VISUAL
37 # Each test should start with something like this, after copyright notices:
38 #
39 # test_description='Description of this test...
40 # This test checks if command xyzzy does the right thing...
41 # '
42 # . ./test-lib.sh
44 error () {
45         echo "* error: $*"
46         trap - exit
47         exit 1
48 }
50 say () {
51         echo "* $*"
52 }
54 test "${test_description}" != "" ||
55 error "Test script did not set test_description."
57 while test "$#" -ne 0
58 do
59         case "$1" in
60         -d|--d|--de|--deb|--debu|--debug)
61                 debug=t; shift ;;
62         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
63                 immediate=t; shift ;;
64         -h|--h|--he|--hel|--help)
65                 echo "$test_description"
66                 exit 0 ;;
67         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
68                 verbose=t; shift ;;
69         --no-python)
70                 no_python=t; shift ;;
71         *)
72                 break ;;
73         esac
74 done
76 exec 5>&1
77 if test "$verbose" = "t"
78 then
79         exec 4>&2 3>&1
80 else
81         exec 4>/dev/null 3>/dev/null
82 fi
84 test_failure=0
85 test_count=0
87 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
90 # You are not expected to call test_ok_ and test_failure_ directly, use
91 # the text_expect_* functions instead.
93 test_ok_ () {
94         test_count=$(expr "$test_count" + 1)
95         say "  ok $test_count: $@"
96 }
98 test_failure_ () {
99         test_count=$(expr "$test_count" + 1)
100         test_failure=$(expr "$test_failure" + 1);
101         say "FAIL $test_count: $1"
102         shift
103         echo "$@" | sed -e 's/^/        /'
104         test "$immediate" = "" || { trap - exit; exit 1; }
108 test_debug () {
109         test "$debug" = "" || eval "$1"
112 test_run_ () {
113         eval >&3 2>&4 "$1"
114         eval_ret="$?"
115         return 0
118 test_expect_failure () {
119         test "$#" = 2 ||
120         error "bug in the test script: not 2 parameters to test-expect-failure"
121         say >&3 "expecting failure: $2"
122         test_run_ "$2"
123         if [ "$?" = 0 -a "$eval_ret" != 0 ]
124         then
125                 test_ok_ "$1"
126         else
127                 test_failure_ "$@"
128         fi
131 test_expect_success () {
132         test "$#" = 2 ||
133         error "bug in the test script: not 2 parameters to test-expect-success"
134         say >&3 "expecting success: $2"
135         test_run_ "$2"
136         if [ "$?" = 0 -a "$eval_ret" = 0 ]
137         then
138                 test_ok_ "$1"
139         else
140                 test_failure_ "$@"
141         fi
144 test_expect_code () {
145         test "$#" = 3 ||
146         error "bug in the test script: not 3 parameters to test-expect-code"
147         say >&3 "expecting exit code $1: $3"
148         test_run_ "$3"
149         if [ "$?" = 0 -a "$eval_ret" = "$1" ]
150         then
151                 test_ok_ "$2"
152         else
153                 test_failure_ "$@"
154         fi
157 # Most tests can use the created repository, but some amy need to create more.
158 # Usage: test_create_repo <directory>
159 test_create_repo () {
160         test "$#" = 1 ||
161         error "bug in the test script: not 1 parameter to test-create-repo"
162         owd=`pwd`
163         repo="$1"
164         mkdir "$repo"
165         cd "$repo" || error "Cannot setup test environment"
166         "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
167         error "cannot run git init-db -- have you built things yet?"
168         mv .git/hooks .git/hooks-disabled
169         cd "$owd"
171         
172 test_done () {
173         trap - exit
174         case "$test_failure" in
175         0)
176                 # We could:
177                 # cd .. && rm -fr trash
178                 # but that means we forbid any tests that use their own
179                 # subdirectory from calling test_done without coming back
180                 # to where they started from.
181                 # The Makefile provided will clean this test area so
182                 # we will leave things as they are.
184                 say "passed all $test_count test(s)"
185                 exit 0 ;;
187         *)
188                 say "failed $test_failure among $test_count test(s)"
189                 exit 1 ;;
191         esac
194 # Test the binaries we have just built.  The tests are kept in
195 # t/ subdirectory and are run in trash subdirectory.
196 PATH=$(pwd)/..:$PATH
197 GIT_EXEC_PATH=$(pwd)/..
198 export PATH GIT_EXEC_PATH
200 # Similarly use ../compat/subprocess.py if our python does not
201 # have subprocess.py on its own.
202 PYTHON=`sed -e '1{
203         s/^#!//
204         q
205 }' ../git-merge-recursive` || {
206         error "You haven't built things yet, have you?"
208 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
209         PYTHONPATH=$(pwd)/../compat
210         export PYTHONPATH
212 test -d ../templates/blt || {
213         error "You haven't built things yet, have you?"
216 # Test repository
217 test=trash
218 rm -fr "$test"
219 test_create_repo $test
220 cd "$test"